=== debian/changelog ===
mfem (4.9+ds-2) unstable; urgency=medium

  * d/control: unversion hypre build-depends. (Closes: #1122615)
  * d/changelog: remove wrong bug number from previous upload.

 -- Alex Myczko <tar@debian.org>  Wed, 17 Dec 2025 11:20:11 +0000

mfem (4.9+ds-1) experimental; urgency=medium

  * New upstream version.
  * d/control: version hypre build-depends.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Fri, 12 Dec 2025 09:32:39 +0000
