=== debian/watch ===
Version: 5

# GitHub hosted projects
Template: Github
Owner: mfem
Project: mfem
Update-Script: uupdate
